package dareka.processor.impl;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.extensions.Rewriter;
import dareka.processor.HttpResponseHeader;

// [nl] watchy[W
public class WatchRewriter implements Rewriter {

	// Rewriter interface
	private static final Pattern WATCH_PAGE_PATTERN = Pattern.compile(
			"^http://(?:www|flapi)\\.nicovideo\\.jp/watch/([a-z]{2})?(\\d+)" +
			"(|\\?.+|/videoExplorer)$");
	
	// URL̐K\
	public Pattern getRewriterSupportedURLAsPattern() {
		return WATCH_PAGE_PATTERN;
	}
	
	public String onMatch(Matcher match, HttpResponseHeader responseHeader, String content)
			throws IOException {
		String type = match.group(1);
		String id   = match.group(2);
		
		//
		// WatchVars 𐶐ăLbV
		// ȍ~ Rewriter ̓LbV WatchVars 𗘗pł
		//
		WatchVars vars = WatchVars.get(content);
		
		// XbhID̏ꍇ͓IDƂ̑ΉL^
		if (type == null && vars.getVideoId() != null) {
			NLShared.INSTANCE.putThread2Smid(id, vars.getVideoId());
		}
		
		if (Boolean.getBoolean("disableWatchRewriter")) {
			return content;
		}
		
		// GINZA: flvInfo(=getflv𔭍sȂ)P[XɑΉ
		vars.replaceFlvInfo(match.group());
        // HTML5
        vars.replaceDataApiData(match.group());
		
		return vars.getReplacedContent();
	}
	
}
